##
## clirc -- An IRC client in Python.
## reloader.py - Class identity preserving reloading.
##
## Copyleft 1997-2001 Teemu Kalvas <chery@s2.org>
##

import imp
import sys
import types

module_names = []

protected_names = {'__name__': (), '__builtins__': ()}

class ValueDefaulter:
    def __init__(self):
        if hasattr(self, 'defaults'):
            set_defaults(self.__class__.__dict__, self.defaults)

def set_defaults(dict, defaults):
    for key, value in defaults.items():
        if callable(value):
            value = value()
        dict[key] = value

def move_values(dict, items):
    for key, value in items:
        if not protected_names.has_key(key):
            if type(value) <> types.ModuleType or not dict.has_key(key):
                if type(value) <> types.ClassType or not dict.has_key(key):
                    dict[key] = value
                else:
                    class_dict = dict[key].__dict__
                    move_values(class_dict, value.__dict__.items())
                    if class_dict.has_key('defaults'):
                        set_defaults(class_dict, class_dict['defaults'])

def reload_module(module_name):
    module = sys.modules[module_name]
    old_classes = {}
    for key, value in module.__dict__.items():
        if type(value) == types.ClassType:
            old_classes[key] = value
    reload(module)
    for key, value in old_classes.items():
        if module.__dict__.has_key(key):
            if type(module.__dict__[key]) == types.ClassType:
                move_values(value.__dict__, module.__dict__[key].__dict__.items())
                if value.__dict__.has_key('defaults'):
                    set_defaults(value.__dict__, value.defaults)
                module.__dict__[key] = value
        else:
            module.__dict__[key] = value

def do_reloads():
    global module_names
    module_names_copy = module_names
    module_names = []
    for module_name in module_names_copy:
        reload_module(module_name)

def register_module(module_name):
    """Register a module to be reloaded when do_reloads is called.  Modules
should be registered in the order in which they are initially loaded to
minimize interdependency problems."""
    module_names.append(module_name)

## End. ##
